import modin.pandas as pandas
import numpy as np
import datetime
import time


def replace_useragents(data):
    #useragents = data.loc[(data["client"] != "empty")]
    data["client"].fillna('-1', inplace=True)
    useragents = data["client"].astype(str)

    #Thunderbird / Codename Lanikai for TB3
    useragents=useragents.str.replace('Mozilla\/5\.0\W*\(Windows(.*)\)\W*Gecko\/[0-9]*\W.*\W*[Thunderbird|Lanikai]\/[0-9.a-z]*\W*.*', '[i]TB-Win', regex=True)
    useragents=useragents.str.replace('Mozilla\/5\.0\W*\(Macintosh(.*)\)\W*Gecko\/[0-9]*\W.*\W*[Thunderbird|Lanikai]\/[0-9.a-z]*\W*.*', '[i]TB-Mac', regex=True)
    useragents=useragents.str.replace('(Debian)*\W*\/*[0-9.a-z-]*\W*Mozilla\/5\.0\W*\(X11(.*)\)\W*Gecko\/[0-9]*\W*.*\W*[Thunderbird|Lanikai]\/[0-9.a-z]*\W*.*', '[i]TB-Linux', regex=True)

    useragents=useragents.str.replace('Mozilla\/5\.0\W*\(Windows(.*)\)\W*Gecko\/[0-9]*\W.*\W*Ice[d|D]ove\/[0-9.a-z]*\W*.*', '[i]Icedove-Win', regex=True)
    useragents=useragents.str.replace('Mozilla\/5\.0\W*\(Macintosh(.*)\)\W*Gecko\/[0-9]*\W.*\W*Ice[d|D]ove\/[0-9.a-z]*\W*.*', '[i]Icedove-Mac', regex=True)
    useragents=useragents.str.replace('Mozilla\/5\.0\W*\(X11(.*)\)\W*Gecko\/[0-9]*\W*.*\W*Ice[d|D]ove\/[0-9.a-z]*\W*.*', '[i]Icedove-Linux', regex=True)

    useragents=useragents.str.replace('Mozilla\/5\.0\W*\(Windows(.*)\)\W*Gecko\/[0-9]*\W.*\W*Netscape\/[0-9.a-z]*\W*.*', '[i]Netscape-Win', regex=True)
    useragents=useragents.str.replace('Mozilla\/5\.0\W*\(Macintosh(.*)\)\W*Gecko\/[0-9]*\W.*\W*Netscape\/[0-9.a-z]*\W*.*', '[i]Netscape-Mac', regex=True)
    useragents=useragents.str.replace('Mozilla\/5\.0\W*\(X11(.*)\)\W*Gecko\/[0-9]*\W*.*\W*Netscape\/[0-9.a-z]*\W*.*', '[i]Netscape-Linux', regex=True)
    useragents=useragents.str.replace('Netscape Communicator', '[i]Netscape', regex=True)

    useragents=useragents.str.replace('Mozilla\/5\.0\W*\(Windows(.*)\)\W*Gecko\/[0-9]*\W.*\W*SeaMonkey\/[0-9.a-z]*\W*.*', '[i]Seamonkey-Win', regex=True)
    useragents=useragents.str.replace('Mozilla\/5\.0\W*\(Macintosh(.*)\)\W*Gecko\/[0-9]*\W.*\W*SeaMonkey\/[0-9.a-z]*\W*.*', '[i]Seamonkey-Mac', regex=True)
    useragents=useragents.str.replace('Mozilla\/5\.0\W*\(X11(.*)\)\W*Gecko\/[0-9]*\W*.*\W*SeaMonkey\/[0-9.a-z]*\W*.*', '[i]Seamonkey-Linux', regex=True)

    #Early TB Versions <=3
    useragents=useragents.str.replace('[Debian|Mozilla]*-*\W*Thunderbird\W*[0-9.a-z-]*\W*\(Windows.*', '[i]TB-Win', regex=True)
    useragents=useragents.str.replace('(Debian)*\W*\/*[0-9.a-z-]*\W*[Mozilla]*-*\W*Thunderbird\W*[0-9.a-z-]*\W*\(X11.*', '[i]TB-Linux', regex=True)
    useragents=useragents.str.replace('[Debian|Mozilla]*-*\W*Thunderbird\W*[0-9.a-z-]*\W*\(Macintosh.*', '[i]TB-Mac', regex=True)

    #Unknown Thunderbird versions
    useragents=useragents.str.replace('[Debian|Mozilla]*-*\W*Thunderbird\/[0-9.a-z]*.*', '[i]TB-unknown', regex=True)
    useragents=useragents.str.replace('Thunderbird-Portable.*', '[i]TB-Portable', regex=True)

    #Catch any remainder
    useragents=useragents.str.replace('.*Thunderbird.*', '[i]TB-unknown', regex=True)

    #Early Icedove Versions <=3
    useragents=useragents.str.replace('[Mozilla]*-*\W*Ice[d|D]ove\W*[0-9.a-z-]*\W*\(Windows\/[0-9]*\).*', '[i]Icedove-Win', regex=True)
    useragents=useragents.str.replace('(Debian\W*[0-9.a-z-])*[Mozilla]*-*\W*Ice[d|D]ove\W*[0-9.a-z-]*\W*\(X11\/[0-9]*\).*', '[i]Icedove-Linux', regex=True)
    useragents=useragents.str.replace('[Mozilla]*-*\W*Ice[d|D]ove\W*[0-9.a-z-]*\W*\(Macintosh\/[0-9]*\).*', '[i]Icedove-Mac', regex=True)

    #Outlook Express
    useragents=useragents.str.replace('^(Microsoft Windows Mail).*', '[i]OExpress', regex=True)
    useragents=useragents.str.replace('^(Microsoft Windows Live Mail).*', '[i]OExpress', regex=True)
    useragents=useragents.str.replace('^(Microsoft Outlook Express).*', '[i]OExpress', regex=True)
    useragents=useragents.str.replace('^(Microsoft-Outlook-Express-Macintosh-Edition).*', '[i]OExpress', regex=True)
    useragents=useragents.str.replace('^(OE for Linux).*', '[i]OExpress', regex=True)


    useragents=useragents.str.replace('^(Microsoft Office Outlook).*', '[i]Outlook', regex=True)
    #Useragent changed with Outlook 13
    useragents=useragents.str.replace('^(Microsoft Outlook).*', '[i]Outlook', regex=True)

    useragents = useragents.str.replace('^(Outlook for iOS and Android).*', '[i]Outlook', regex=True)

    #Mac Stuff
    useragents = useragents.str.replace('^(Apple Mail).*', '[i]AppleMail', regex=True)
    useragents = useragents.str.replace('^(iPhone Mail).*', '[i]iPhoneMail', regex=True)
    useragents = useragents.str.replace('^(iPad Mail).*', '[i]iPadMail', regex=True)
    useragents=useragents.str.replace('Microsoft-MacOutlook.*', '[i]Outlook-Mac', regex=True)
    useragents=useragents.str.replace('Mozilla\/5\.0\W*\(Macintosh(.*)\)\W*Gecko\/[0-9]*\W.*\W*PostboxApp\/[0-9.]*\W*.*', '[i]PostboxApp-Mac', regex=True)
    useragents=useragents.str.replace('^Postbox\W*[0-9.]*\W*(Macintosh.*)', '[i]Postbox-Mac', regex=True)
    useragents = useragents.str.replace('^(MailMate).*', '[i]MailMate', regex=True)


    useragents=useragents.str.replace('Mozilla\/5\.0\W*\(Macintosh(.*)\)\W*Gecko\/[0-9]*\W.*\W*PostboxApp\/[0-9.]*\W*.*', '[i]PostboxApp-Mac', regex=True)

    #UniMail
    useragents=useragents.str.replace('^(Internet Messaging Program).*', '[i]Internet Messaging Program', regex=True)
    useragents=useragents.str.replace('SOGoMail.*', '[i]SOGoMail', regex=True)
    useragents=useragents.str.replace('Horde Application Framework\W*[0-9.]*', '[i]Horde', regex=True)
    useragents=useragents.str.replace('Round[cC]ube Webmail.*', '[i]Roundcube', regex=True)

    useragents=useragents.str.replace('^(Mutt).*', '[i]Mutt', regex=True)
    useragents=useragents.str.replace('^(NeoMutt).*', '[i]NeoMutt', regex=True)
    useragents=useragents.str.replace('^(Alpine).*', '[i]Alpine', regex=True)
    useragents=useragents.str.replace('^(Evolution).*', '[i]Evolution', regex=True)
    useragents=useragents.str.replace('^(KMail).*', '[i]KMail', regex=True)
    useragents=useragents.str.replace('^(mu4e).*', '[i]mu4e', regex=True)
    useragents=useragents.str.replace('^(caff|modified caff).*', '[i]caff', regex=True)
    useragents=useragents.str.replace('^(CAU Webmail).*', '[i]CAU Webmail', regex=True)
    useragents=useragents.str.replace('^(eM_Client).*', '[i]eM_Client', regex=True)
    useragents=useragents.str.replace('^(Opera).*', '[i]Opera Mail', regex=True)
    useragents=useragents.str.replace('^(Notmuch).*', '[i]Notmuch', regex=True)
    useragents=useragents.str.replace('^(AquaMail).*', '[i]AquaMail', regex=True)
    useragents=useragents.str.replace('^(SquirrelMail).*', '[i]SquirrelMail', regex=True)
    useragents=useragents.str.replace('^(astroid).*', '[i]astroid', regex=True)
    useragents=useragents.str.replace('^(Cyrus-JMAP).*', '[i]Cyrus-JMAP', regex=True)
    useragents=useragents.str.replace('^(Gnus\/).*', '[i]Gnus', regex=True)
    useragents=useragents.str.replace('^(Microsoft-Entourage\/).*', '[i]Microsoft-Entourage', regex=True)
    useragents=useragents.str.replace('^(Microsoft CDO).*', '[i]Microsoft-CDO', regex=True)
    useragents=useragents.str.replace('^(MailDroid\/).*', '[i]MailDroid', regex=True)
    useragents=useragents.str.replace('^(alot\/).*', '[i]alot', regex=True)
    useragents=useragents.str.replace('^(mutt-ng\/).*', '[i]mutt-ng', regex=True)
    useragents=useragents.str.replace('^(Heirloom mailx).*', '[i]heirloom-mailx', regex=True)
    #nail is the previous name of heirloom mailx
    useragents=useragents.str.replace('^(nail).*', '[i]heirloom-mailx', regex=True)
    useragents=useragents.str.replace('^(K-9 Mail for Android).*', '[i]K9-Android', regex=True)
    useragents=useragents.str.replace('^(MailChimp).*', '[i]MailChimp', regex=True)
    useragents=useragents.str.replace('^(BME Mailer).*', '[i]BME Mailer', regex=True)
    useragents=useragents.str.replace('^(Mailster).*', '[i]Mailster', regex=True)
    useragents=useragents.str.replace('^(eC\W*-\W*Messenger).*', '[i]eC-Messenger', regex=True)
    useragents=useragents.str.replace('^(The\W*Bat!).*', '[i]TheBat', regex=True)
    useragents=useragents.str.replace('.*(YahooMail).*', '[i]YahooMail', regex=True)
    useragents=useragents.str.replace('WebService\/[0-9.]*\WYMail.*', '[i]YahooMail', regex=True)
    useragents=useragents.str.replace('WebService\/[0-9.]*.*', '[i]WebService', regex=True)
    useragents=useragents.str.replace('^([d|D]avid).* by [t|T]obit.*', '[i]david.fx', regex=True)
    useragents=useragents.str.replace('^(Zimbra).*', '[i]Zimbra', regex=True)
    useragents=useragents.str.replace('^(Open-Xchange Mailer).*', '[i]OpenXChange', regex=True)
    useragents=useragents.str.replace('^(Mail.Ru Mailer).*', '[i]Mail.Ru', regex=True)
    useragents=useragents.str.replace('^(TYPO3).*', '[i]TYPO3', regex=True)
    useragents=useragents.str.replace('^(Novell GroupWise Internet Agent).*', '[i]Novell GroupWise', regex=True)
    useragents=useragents.str.replace('^(nlserver).*', '[i]nlserver', regex=True)
    useragents=useragents.str.replace('^(Maileon).*', '[i]Maileon', regex=True)
    useragents=useragents.str.replace('^(SAP Net[w|W]eaver).*', '[i]SAP Netweaver', regex=True)
    useragents=useragents.str.replace('^(ProcessWire).*', '[i]ProcessWire', regex=True)
    useragents=useragents.str.replace('.*Global Message Exchange.*', '[i]GMX', regex=True)
    useragents=useragents.str.replace('^(Claws Mail).*', '[i]Claws Mail', regex=True)
    useragents=useragents.str.replace('^(CommuniGate Pro MAPI).*', '[i]CommuniGate Pro', regex=True)
    useragents=useragents.str.replace('^(ablesen.de).*', '[i]ablesen.de', regex=True)


    #Ticketsystems
    useragents=useragents.str.replace('^(K[i|I][x|X] Pro).*', '[i]Ticketsystem', regex=True)
    useragents=useragents.str.replace('^(OTRS Mail Service).*', '[i]Ticketsystem', regex=True)


    #Marketing
    useragents=useragents.str.replace('^(Create Send).*', '[i]MarketingTool', regex=True)
    useragents=useragents.str.replace('^(Roving Constant Contact 2012).*', '[i]MarketingTool', regex=True)
    useragents=useragents.str.replace('^(GetResponse 360).*', '[i]MarketingTool', regex=True)
    useragents=useragents.str.replace('^(Mailingwork).*', '[i]MarketingTool', regex=True)
    useragents=useragents.str.replace('^(Sendin[B|b]lue).*', '[i]MarketingTool', regex=True)


    #Development Frameworks
    useragents=useragents.str.replace('^(class SMTPMail).*', '[i]DevFramework', regex=True)
    useragents=useragents.str.replace('^(Framework::Mail).*', '[i]DevFramework', regex=True)
    useragents=useragents.str.replace('^(MIME::Lite).*', '[i]DevFramework', regex=True)
    useragents=useragents.str.replace('^(PHPMailer).*', '[i]DevFramework', regex=True)
    useragents=useragents.str.replace('^(MIME-tools).*', '[i]DevFramework', regex=True)

    #Other Gecko Based that we cannot identify
    #Remove RUB, because it would get falsely identified as Gecko.
    useragents=useragents.str.replace('^[^(RUB Webmail)]*Mozilla\/5\.0.*Gecko\/[0-9]*.*', '[i]Unidentified Gecko Based Client', regex=True)
    useragents=useragents.str.replace('^[^(RUB Webmail)]*Mozilla\/5\.0.*', '[i]Unidentified Mozilla Based Client', regex=True)

    useragents=useragents.str.replace('-1', '[i]No Useragent')

    useragents=useragents.str.replace('.*[w|W]ebmail.*', '[i]Webmail Client', regex=True)
    useragents=useragents.str.replace('.*freenet.*', '[i]Webmail Client', regex=True)

    #the following is mainly used to get a list of useragents
    #unique_useragents = pandas.unique(useragents)
    #print("\n".join(map(str, unique_useragents)))

    #print(useragents.value_counts().nlargest(50))
    #data["client_merged"] = useragents
    #sent_mails_df = get_sent_mails(data)
    #print("----------------SENT---------------------------------")
    #print(sent_mails_df["client_merged"].value_counts().nlargest(50))
    #sent_sig_mails = sent_mails_df.loc[
    #    ((sent_mails_df["smime_sig_fixed"] == True) | (sent_mails_df["pgp_sig_attachment_fixed"] == True) | (sent_mails_df["pgp_signature_inline"] != "PGPSig.un"))]

    #print("-----------------------------------------------------")
    #print(sent_sig_mails["client_merged"].value_counts().nlargest(50))
    #print("-----------------------------------------------------")

    #received_mails_df = get_received_mails(data)
    #print("----------------RECEIVED SMIME---------------------------------")
    #received_mails_df = received_mails_df.loc[
    #    ((received_mails_df["smime_sig_fixed"] == True) | (received_mails_df["pgp_sig_attachment_fixed"] == True) | (received_mails_df["pgp_signature_inline"] != "PGPSig.un"))]
    #print(received_mails_df["client_merged"].value_counts().nlargest(50))

    #print("-----------------------------------------------------")
    #print(sent_sig_mails["client_merged"].value_counts().nlargest(50))
    #print("-----------------------------------------------------")

    #data["return_path"].fillna('empty', inplace=True)
    #data['return_path_set'] = (data["return_path"] == "empty")
    #apple_mail_users = data.loc[((data["client_merged"] == "[i]AppleMail"))]
    #print("AppleMail Users: ", apple_mail_users.shape[0])
    #apple_grouped = apple_mail_users.groupby(['folder']).agg(
    #    {'mail_relay_count': ['count', 'min', 'max', 'mean', 'median']})
    #print(apple_grouped)

    #apple_grouped = apple_mail_users.groupby(['folder', 'return_path_set']).agg(
    #    {'mail_relay_count': ['count', 'min', 'max', 'mean', 'median']})
    #print(apple_grouped)

    #Apple Mail Debug:
    #apple_mail_users = data.loc[((data["client_merged"] == "[i]AppleMail") & (data["mail_relay_count"] <= 1) & (data["return_path"] == "empty") & (data['folder'].str.contains('Postbox.Other')))]
    #apple_debug1 = apple_mail_users.groupby(
    #    'user').agg(
    #    {'sender': ['nunique']})
    #print(apple_debug1)
    #apple_debug1.to_csv("~/debug/apple1a.csv")

    #Apple Mail Debug:
    #apple_mail_users = data.loc[((data["client_merged"] == "[i]iPhoneMail") & (data["mail_relay_count"] <= 1) & (data["return_path"] == "empty") & (data['folder'].str.contains('Postbox.Other')))]
    #apple_debug1 = apple_mail_users.groupby(
    #    'user').agg(
    #    {'sender': ['nunique']})
    #print(apple_debug1)
    #apple_debug1.to_csv("~/debug/apple2a.csv")

    #Apple Mail Debug:
    #apple_mail_users = data.loc[((data["client_merged"] == "[i]iPadMail") & (data["mail_relay_count"] <= 1) & (data["return_path"] == "empty") & (data['folder'].str.contains('Postbox.Other')))]
    #apple_debug1 = apple_mail_users.groupby(
    #    'user').agg(
    #    {'sender': ['nunique']})
    #print(apple_debug1)
    #apple_debug1.to_csv("~/debug/apple3a.csv")

    useragents=useragents.str.replace('^(?!\[i\]).*', '[i]Other', regex=True)
    #print(useragents.value_counts().nlargest(50))
    data["client_merged"] = useragents

    return data

def replace_useragents_top5(data):
    #useragents = data.loc[(data["client"] != "empty")]
    data["client_merged"].fillna('-1', inplace=True)
    useragents = data["client_merged"].astype(str)

    useragents=useragents.str.replace('\[i\]TB.*', '[d]Thunderbird', regex=True) #1
    useragents=useragents.str.replace('\[i\]Outlook.*', '[d]Outlook', regex=True) #2
    useragents=useragents.str.replace('\[i\]Ticketsystem', '[d]Ticketsystem', regex=True) #3
    useragents=useragents.str.replace('\[i\]AppleMail.*', '[d]AppleMail', regex=True) #4
    useragents=useragents.str.replace('\[i\]Evolution.*', '[d]Evolution', regex=True) #5
    useragents=useragents.str.replace('\[i\]Mutt', '[d]Mutt/NeoMutt', regex=True) #6
    useragents=useragents.str.replace('\[i\]NeoMutt.*', '[d]Mutt/NeoMutt', regex=True) #6
    useragents=useragents.str.replace('\[i\]mutt-ng.*', '[d]Mutt/NeoMutt', regex=True) #6
    useragents=useragents.str.replace('\[i\]OExpress.*', '[d]Outlook-Express', regex=True) #7
    useragents=useragents.str.replace('\[i\]iPhoneMail.*', '[d]iPhone/iPad-Mail', regex=True) #8
    useragents=useragents.str.replace('\[i\]iPadMail.*', '[d]iPhone/iPad-Mail', regex=True) #8
    useragents=useragents.str.replace('\[i\]Claws Mail.*', '[d]Claws Mail', regex=True) #9
    useragents=useragents.str.replace('\[i\]MailMate.*', '[d]MailMate', regex=True) #10
    #useragents=useragents.str.replace('\[i\]mu4e.*', '[d]mu4e', regex=True) #5
    #useragents=useragents.str.replace('\[i\]KMail.*', '[d]KMail', regex=True) #78
    #useragents=useragents.str.replace('\[i\]eM_Client.*', '[d]eM_Client', regex=True) #9
    #useragents=useragents.str.replace('\[i\]Netscape.*', '[d]Netscape', regex=True) #10

    #useragents=useragents.str.replace('\[i\]iPadMail.*', '[d]iPadMail', regex=True) #1
    #useragents=useragents.str.replace('\[i\]K9-Android.*', '[d]K9-Android', regex=True) #7
    #useragents=useragents.str.replace('\[i\]Internet Messaging Program.*', '[d]Internet Messaging Program', regex=True) #7
    #useragents=useragents.str.replace('\[i\]PHPMailer.*', '[d]PHPMailer', regex=True) #7
    #useragents=useragents.str.replace('\[i\]OTRS Mail Service Ticketsystem.*', '[d]OTRS Mail Service Ticketsystem', regex=True) #7
    #useragents=useragents.str.replace('.*\[i\]Unidentified Gecko Based Client.*', '[d]Unknown Gecko/Mozilla', regex=True) #8
    #useragents=useragents.str.replace('.*\[i\]Unidentified Mozilla Based Client.*', '[d]Unknown Gecko/Mozilla', regex=True) #8
    #useragents=useragents.str.replace('\[i\]MarketingTool.*', '[d]MarketingTool', regex=True) #7
    #useragents=useragents.str.replace('\[i\]DevFramework.*', '[d]DevFramework', regex=True) #7
    #useragents=useragents.str.replace('\[i\]ablesen.*', '[d]ablesen.de', regex=True) #7
    print(useragents.value_counts().nlargest(50))
    #useragents=useragents.str.replace('\[i\]SOGoMail.*', '[d]SOGoMail', regex=True) #9
    #useragents=useragents.str.replace('\[i\]Outlook-Mac.*', '[d]Outlook-Mac', regex=True) #10

    #No Useragent and other at the end
    useragents=useragents.str.replace('\[i\]No Useragent', '[d]No Useragent') #11
    useragents=useragents.str.replace('^(?!\[d\]).*', '[d]Other', regex=True) #12

    data["client_merged_top5"] = useragents
    print(useragents.value_counts().nlargest(50))

    return data

def replace_operating_system(data):
    #useragents = data.loc[(data["client"] != "empty")]
    data["client"].fillna('-1', inplace=True)
    useragents = data["client"].astype(str)

    #Thunderbird / Codename Lanikai for TB3
    useragents=useragents.str.replace('.*[W|w]indows.*', '[i]Win', regex=True)
    useragents=useragents.str.replace('.*[A|a]ndroid.*', '[i]Android', regex=True)
    useragents=useragents.str.replace('.*[M|m]ac.*', '[i]Mac', regex=True)
    useragents=useragents.str.replace('.*[M|m]ail[M|m]ate.*', '[i]Mac', regex=True)
    useragents=useragents.str.replace('^(Apple Mail).*', '[i]Mac', regex=True)
    useragents=useragents.str.replace('.*[X|x]11.*', '[i]Linux', regex=True)
    useragents=useragents.str.replace('.*[L|l]inux.*', '[i]Linux', regex=True)
    useragents=useragents.str.replace('.*[c|C]entos.*', '[i]Linux', regex=True)
    useragents=useragents.str.replace('.*[d|D]ebian.*', '[i]Linux', regex=True)
    useragents=useragents.str.replace('.*[M|m]ail[M|m]ate.*', '[i]Linux', regex=True)

    useragents=useragents.str.replace('.*[W|w]eb[M|m]ail.*', '[i]Webmail', regex=True)
    useragents=useragents.str.replace('.*[O|o]nline.*', '[i]Webmail', regex=True)
    useragents=useragents.str.replace('.*freenet.*', '[i]Webmail', regex=True)
    useragents=useragents.str.replace('.*SOGo.*', '[i]Webmail', regex=True)
    useragents=useragents.str.replace('.*Horde.*', '[i]Webmail', regex=True)
    useragents=useragents.str.replace('^(Internet Messaging Program).*', '[i]Webmail', regex=True)
    useragents=useragents.str.replace('Round[cC]ube Webmail.*', '[i]Webmail', regex=True)

    useragents=useragents.str.replace('^(iPhone Mail).*', '[i]iOS', regex=True)
    useragents=useragents.str.replace('^(iPad Mail).*', '[i]iOS', regex=True)
    useragents=useragents.str.replace('.*i[o|O][s|S].*', '[i]iOS', regex=True)
    useragents=useragents.str.replace('-1', '[i]No Useragent')
    useragents=useragents.str.replace('^(?!\[i\]).*', '[i]Unknown', regex=True)

    #unique_useragents = pandas.unique(useragents)
    #print("\n".join(map(str,unique_useragents)))

    data["operating_system"] = useragents

    return data


def add_level_info_fix_crypto(data):
    #Mails are only signed/encrypted if level is 0 or 1, otherwise the mail is forwarded.

    smime_level_data = data["cert_data"].astype(str)
    pgp_attachment_enc_level_data = data["pgp_encryption_attachment"].astype(str)
    pgp_attachment_sig_level_data = data["pgp_signature_attachment"].astype(str)
    pgp_attachment_key_level_data = data["pgp_key_data_attachment"].astype(str)

    smime_level_data = smime_level_data.str.replace('.*"level":\s*([0-9]*).*', r'\1', regex=True)
    pgp_attachment_enc_level_data = pgp_attachment_enc_level_data.str.replace('.*\'level\':\s*([0-9]*).*', r'\1', regex=True)
    pgp_attachment_sig_level_data = pgp_attachment_sig_level_data.str.replace('.*\'level\':\s*([0-9]*).*', r'\1', regex=True)
    pgp_attachment_key_level_data = pgp_attachment_key_level_data.str.replace('.*\'level\':\s*([0-9]*).*', r'\1', regex=True)


    data["smime_level"] = pandas.to_numeric(smime_level_data, errors="coerce")
    data["pgp_enc_attachment_level"] = pandas.to_numeric(pgp_attachment_enc_level_data, errors="coerce")
    data["pgp_sig_attachment_level"] = pandas.to_numeric(pgp_attachment_sig_level_data, errors="coerce")
    data["pgp_key_attachment_level"] = pandas.to_numeric(pgp_attachment_key_level_data, errors="coerce")

    data['smime_sig_fixed'] = ((data["smime_signature"] == "SMIMESig.sig") & (data["smime_level"] <= 2))
    data['pgp_enc_attachment_fixed'] = ((data["pgp_encryption_attachment"] != "PGPEnc.un") & (data["pgp_enc_attachment_level"] <= 2))
    data['pgp_sig_attachment_fixed'] = ((data["pgp_signature_attachment"] != "PGPSig.un") & (data["pgp_sig_attachment_level"] <= 2))
    data['pgp_key_attachment_fixed'] = ((data["pgp_key_data_attachment"].str.contains("type")) & (data["pgp_enc_attachment_level"] <= 2))

    return data

def filter_for_year(df, year):
    if year != None:
        if not isinstance(year, str):
            year = str(year)
        new_df = df.loc[df["header_date"].astype('str').str.slice(0, 4) == year]
        return new_df
   
    return []

def time_distance(start, end):
    """
    Calculates the distance between the start and end date in weeks.
    Start and end have the form: KW:YEAR
    """
    # A small hack... we can only use the week number with a day...
    start = pandas.to_datetime(start+ '0', format='%W:%Y%w')
    end = pandas.to_datetime(end+ '0', format='%W:%Y%w')
    lifetime = (end - start) / np.timedelta64(1, 'D')
    return lifetime

def split_data_frame_list(df, target_column):
    """
    Splits a column with lists into rows
    
    Keyword arguments:
        df -- dataframe
        target_column -- name of column that contains lists
    See: https://gist.github.com/jlln/338b4b0b55bd6984f883
    """
    
    # create a new dataframe with each item in a seperate column, dropping rows with missing values
    col_df = pandas.DataFrame(df[target_column].dropna().tolist(),index=df[target_column].dropna().index)

    # create a series with columns stacked as rows
    stacked = col_df.stack()

    # rename last column to 'idx'
    index = stacked.index.rename(names="idx", level=-1)
    new_df = pandas.DataFrame(stacked, index=index, columns=[target_column])
    return new_df

def get_sent_mails(data):
    return data.loc[(data['is_sent'] == True)]

def get_received_mails(data):
    return data.loc[(data['is_sent'] == False)]
