import matplotlib.pyplot as plt
import seaborn as sns
from matplotlib import rcParams
from matplotlib.lines import Line2D
import load_data
rcParams.update({'figure.autolayout': True})

def seaborn_boxplot_paper(filename, data, x_var, y_var, hue = None, hue_order = None, xlabel = None, ylabel = None, testrun = True, hide_legend = False, xsize=6, ysize=4, colors = None, show_xticks = False):
    plt.clf()
    plt.figure(figsize=(xsize, ysize))
    ax = sns.boxplot(x=x_var, y=y_var, hue=hue, data=data, hue_order=hue_order, palette="coolwarm_r")

    if colors is not None:
        i = 0
        for patch in ax.artists:
            patch.set_facecolor(colors[i])
            i+=1

    if not show_xticks:
        ax.xaxis.set_ticks_position('none')
    ax.set(xlabel=xlabel)
    ax.set(ylabel=ylabel)
    ax.tick_params("y", labelsize="x-small")
    # plt.suptitle('"Which online communication tools have you used in the last 6 months?" (multiple answers, n = {})'.format(len(qual_tools_full.index)),fontsize=10,wrap=True,ha="center")
    if y_var is None:
        sns.despine(offset=5, trim=True, left=False, bottom=True)
    else:
        sns.despine(offset=5, trim=True, bottom=True)

    ax.legend().set_title("Type")
    if hide_legend:
        ax.legend().remove()

    fig = ax.get_figure()
    fig.savefig(load_data.get_cache_path('graphs/paper/'+filename, testrun))