import matplotlib
matplotlib.use('Agg')
import matplotlib.pyplot as plt
import seaborn as sns
from matplotlib import rcParams
from matplotlib.lines import Line2D
import pandas

#rcParams.update({'figure.autolayout': True})

#Data created by get_sign_by_year in analysis_general_metadata.py.
df = pandas.read_csv("../../ldata/chris_table_sign_enc_per_year.csv", sep=',', quotechar='\'', low_memory=True)

#Areaplot
#ax = df.plot.area(x="header_year", y=["pgp_encrypted_count", "smime_encrypted_count",  "pgp_signed_count", "smime_signed_count"])
#plt.savefig('area.png')

plt.clf()
plt.figure(figsize=(6, 4.5))
sns.set(rc={'figure.figsize':(6,4.5)})
sns.set_theme()
sns.set_style("white")
sns.set_style("ticks")
ax = df.plot(x="header_year",y=["mails","pgp_encrypted_count", "smime_encrypted_count",  "pgp_signed_count", "smime_signed_count"],legend=True, ylim=(10,80000000),xlim=(1994, 2020), logy=True, kind="line")
j = 0
styles=['-', '-.', '--', '-.', '--']
for i, l in enumerate(ax.lines):
    l.set_linestyle(styles[j])
    l.set_linewidth(l.get_linewidth()*1.3)
    print(dir(i))
    print(dir(l))
    j+=1
ax.fill_between(df["header_year"], 0, df["mails"], alpha=0.05)
ax.fill_between(df["header_year"], 0, df["pgp_encrypted_count"], alpha=0.4)
ax.fill_between(df["header_year"], 0, df["smime_encrypted_count"], alpha=0.4)
ax.fill_between(df["header_year"], 0, df["pgp_signed_count"], alpha=0.15)
ax.fill_between(df["header_year"], 0, df["smime_signed_count"], alpha=0.15)
L=plt.legend()
L.get_texts()[0].set_text('Mails')
L.get_texts()[1].set_text('PGP Encrypted')
L.get_texts()[2].set_text('S/MIME Encrypted')
L.get_texts()[3].set_text('PGP Signed')
L.get_texts()[4].set_text('S/MIME Signed')
plt.xlabel("Year")
plt.ylabel("# Mails Per Year")
sns.despine()
plt.savefig('graphs/communication_per_year.png')