#!/usr/bin/env bash

exec 1>>/var/log/mailanalysis/${1}.log
exec 2>>/var/log/mailanalysis/${1}.err

python=./venv/bin/python

user=$1
domain=$( echo $user | cut -d '@' -f 2 )
processid=$$

max_tries=5

try=1
while test $try -le 5; do
        echo "Analysing mailbox $user"
        doveadm -f json fetch -u $user "hdr body imap.bodystructure mailbox user" all | $python main.py --user $user --domain $domain --threadnum $processid

        exitcode=$?
        if test $exitcode -gt 0; then
                echo "$user failed on try $try of $max_tries with exit code $exitcode"
        else
                exit 0
        fi

        try=$(( $try + 1 ))
done