import pytest
import os
import main
import csv
from records.Types import Postbox, SMIMEEnc, SMIMESig, PGPEnc, PGPSig


def test_mail1():
    # Content:
    # Forward as Attachments

    mailnum = 1

    results_test_file = "results/results_forward_mail"+str(mailnum)+".csv"
    try:
        # Delete previous test data
        os.remove(results_test_file)
    except FileNotFoundError:
        pass
    main.main(json_input = "public_testdata/forwards/mail"+str(mailnum)+".json", csv_output = results_test_file, salt = "123".encode())

    #Ensure we don't find any of the personal data in the results file
    with open(results_test_file, 'r') as testfile:
        reader = csv.DictReader(testfile, delimiter=',', quotechar='\'')
        for row in reader:
            assert (row["user"] == "d95b463c813aa61cb0185f7c5a62c95f8b21dc47@sc.h")
            assert (row["sender"] == "91cfc03c27c14c8e4d10ea799abf3d1aa0099874@ext")
            assert (row["receiver_list"] == '["d95b463c813aa61cb0185f7c5a62c95f8b21dc47@sc.h"]')
            assert (row["cc_list"] == "[]")
            assert (row["bcc_list"] == "[]")
            assert (row["reply_to"] == "")
            assert (row["return_path"] == "8870ed84a6276d17d40036917c1964254f76f1de@ext")
            assert (row["header_date"] == "2020-11-22")
            assert (row["client"] == "Mozilla/5.0 (Macintosh; Intel Mac OS X 10.15; rv:68.0) Gecko/20100101 Thunderbird/68.12.0")
            assert (row["folder"] == str(Postbox.inb))
            assert (row["mail_relay_count"] == "9")
            assert (row["mail_virus_scans"] == "1")
            assert (row["message_id"] == "9dcb8bd31112f5454b45bbeed57cf4b439193540")
            #assert (row["dkim"] == "")
            assert (row["is_list"] == "0")
            assert (row["cert_data"] == "")
            assert (row["smime_signature"] == str(SMIMESig.un))
            assert (row["smime_encryption"] == str(SMIMEEnc.un))
            assert (row["autocrypt_data"] == '{"ParserKeyWord.AUTOCRYPT_STATE": "mutual", "ParserKeyWord.AUTOCRYPT_KEY": [{"type": "pub", "length": "4096", "algo": "1", "cap": "scESC", "compliance": "23", "date": "43:2016", "expires": "39:2022", "keyid": "175597d5eab0d7ff13b715d9676236ae34de593a", "subkey_info": {"909e6f4f4d70851fa7a5b0a9fbff22754ddb872c": {"type": "sub", "length": "4096", "algo": "1", "cap": "e", "compliance": "23", "date": "43:2016", "expires": "39:2022", "keyid": "909e6f4f4d70851fa7a5b0a9fbff22754ddb872c"}}, "uids": 1}]}')
            assert (row["pgp_key_data_attachment"] == "[]")
            assert (row["pgp_signature_attachment"] == "{': algo': '1', 'keyid': '15b3306f6f0851a56b10f92bff021058a8ad97cb', 'version': '4', 'sigclass': '0x01', 'digest algo ': '10', 'data': '', 'level': 4}")
            assert (row["pgp_encryption_attachment"] == str(PGPEnc.un))
            assert (row["smime_error"] == "")
            assert (row["pgp_error"] == "")
            assert (row["other_error"] == "")
            print(row['autocrypt_data'])
            print(row['pgp_signature_attachment'])
            print(row['pgp_key_data_attachment'])
            print(row['pgp_encryption_attachment'])

def test_mail2():

    # Content:
    # Hallo, bei der Nachricht habe ich die Signatur extra hinzugefügt.

    mailnum = 2

    results_test_file = "results/results_forward_mail"+str(mailnum)+".csv"
    try:
        #Delete previous test data
        os.remove(results_test_file)
    except FileNotFoundError:
        pass
    main.main(json_input = "public_testdata/forwards/mail"+str(mailnum)+".json", csv_output = results_test_file, salt = "123".encode())

    #Ensure we don't find any of the personal data in the results file
    with open(results_test_file, 'r') as testfile:
        reader = csv.DictReader(testfile, delimiter=',', quotechar='\'')
        for row in reader:
            assert (row["user"] == "d95b463c813aa61cb0185f7c5a62c95f8b21dc47@sc.h")
            assert (row["sender"] == "91cfc03c27c14c8e4d10ea799abf3d1aa0099874@ext")
            assert (row["receiver_list"] == '["d95b463c813aa61cb0185f7c5a62c95f8b21dc47@sc.h"]')
            assert (row["cc_list"] == "[]")
            assert (row["bcc_list"] == "[]")
            assert (row["reply_to"] == "")
            assert (row["return_path"] == "8870ed84a6276d17d40036917c1964254f76f1de@ext")
            assert (row["header_date"] == "2020-11-22")
            assert (row["client"] == "Mozilla/5.0 (Macintosh; Intel Mac OS X 10.15; rv:68.0) Gecko/20100101 Thunderbird/68.12.0")
            assert (row["folder"] == str(Postbox.inb))
            assert (row["mail_relay_count"] == "9")
            assert (row["mail_virus_scans"] == "1")
            assert (row["message_id"] == "a51c27124433474c694bc8940fb86dd411b7a9e0")
            #assert (row["dkim"] == "")
            assert (row["is_list"] == "0")
            assert (row["cert_data"] == "")
            assert (row["smime_signature"] == str(SMIMESig.un))
            assert (row["smime_encryption"] == str(SMIMEEnc.un))
            assert (row["autocrypt_data"] == '{"ParserKeyWord.AUTOCRYPT_STATE": "mutual", "ParserKeyWord.AUTOCRYPT_KEY": [{"type": "pub", "length": "4096", "algo": "1", "cap": "scESC", "compliance": "23", "date": "43:2016", "expires": "39:2022", "keyid": "175597d5eab0d7ff13b715d9676236ae34de593a", "subkey_info": {"909e6f4f4d70851fa7a5b0a9fbff22754ddb872c": {"type": "sub", "length": "4096", "algo": "1", "cap": "e", "compliance": "23", "date": "43:2016", "expires": "39:2022", "keyid": "909e6f4f4d70851fa7a5b0a9fbff22754ddb872c"}}, "uids": 1}]}')
            assert (row["pgp_key_data_attachment"] == "[]")
            assert (row["pgp_signature_attachment"] == str(PGPSig.un))
            assert (row["pgp_encryption_attachment"] == str(PGPEnc.un))
            assert (row["smime_error"] == "")
            assert (row["pgp_error"] == "")
            assert (row["other_error"] == "")

def test_mail3():

    # Content:
    # Jetzt mit AppleMail.

    mailnum = 3

    results_test_file = "results/results_forward_mail"+str(mailnum)+".csv"
    try:
        #Delete previous test data
        os.remove(results_test_file)
    except FileNotFoundError:
        pass
    main.main(json_input = "public_testdata/forwards/mail"+str(mailnum)+".json", csv_output = results_test_file, salt = "123".encode())

    #Ensure we don't find any of the personal data in the results file
    with open(results_test_file, 'r') as testfile:
        reader = csv.DictReader(testfile, delimiter=',', quotechar='\'')
        for row in reader:
            assert (row["user"] == "d95b463c813aa61cb0185f7c5a62c95f8b21dc47@sc.h")
            assert (row["sender"] == "91cfc03c27c14c8e4d10ea799abf3d1aa0099874@ext")
            assert (row["receiver_list"] == '["d95b463c813aa61cb0185f7c5a62c95f8b21dc47@sc.h"]')
            assert (row["cc_list"] == "[]")
            assert (row["bcc_list"] == "[]")
            assert (row["reply_to"] == "")
            assert (row["return_path"] == "8870ed84a6276d17d40036917c1964254f76f1de@ext")
            assert (row["header_date"] == "2020-11-22")
            assert (row["client"] == "Apple Mail (2.3608.120.23.2.4)")
            assert (row["folder"] == str(Postbox.inb))
            assert (row["mail_relay_count"] == "9")
            assert (row["mail_virus_scans"] == "1")
            assert (row["message_id"] == "190ae23255430694891ea4df7e85ffa5d0f02543")
            #assert (row["dkim"] == "")
            assert (row["is_list"] == "0")
            assert (row["cert_data"] == "")
            assert (row["smime_signature"] == str(SMIMESig.unknown))
            assert (row["smime_encryption"] == str(SMIMEEnc.enc))
            assert (row["autocrypt_data"] == '')
            assert (row["pgp_key_data_attachment"] == "[]")
            assert (row["pgp_signature_attachment"] == str(PGPSig.un))
            assert (row["pgp_encryption_attachment"] == str(PGPEnc.un))
            assert (row["smime_error"] == "")
            assert (row["pgp_error"] == "")
            assert (row["other_error"] == "")


def test_mail4():

    #Content:
    #Ein Forward mit Applemail.

    mailnum = 4

    results_test_file = "results/results_forward_mail"+str(mailnum)+".csv"
    try:
        #Delete previous test data
        os.remove(results_test_file)
    except FileNotFoundError:
        pass
    main.main(json_input = "public_testdata/forwards/mail"+str(mailnum)+".json", csv_output = results_test_file, salt = "123".encode())

    #Ensure we don't find any of the personal data in the results file
    with open(results_test_file, 'r') as testfile:
        reader = csv.DictReader(testfile, delimiter=',', quotechar='\'')
        for row in reader:
            assert (row["user"] == "d95b463c813aa61cb0185f7c5a62c95f8b21dc47@sc.h")
            assert (row["sender"] == "91cfc03c27c14c8e4d10ea799abf3d1aa0099874@ext")
            assert (row["receiver_list"] == '["d95b463c813aa61cb0185f7c5a62c95f8b21dc47@sc.h"]')
            assert (row["cc_list"] == "[]")
            assert (row["bcc_list"] == "[]")
            assert (row["reply_to"] == "")
            assert (row["return_path"] == "8870ed84a6276d17d40036917c1964254f76f1de@ext")
            assert (row["header_date"] == "2020-11-22")
            assert (row["client"] == "Apple Mail (2.3608.120.23.2.4)")
            assert (row["folder"] == str(Postbox.inb))
            assert (row["mail_relay_count"] == "9")
            assert (row["mail_virus_scans"] == "1")
            assert (row["message_id"] == "1857b1de95235cfeaa32df0ff90e27a2b1a2580c")
            #assert (row["dkim"] == "")
            assert (row["is_list"] == "0")
            assert (row["cert_data"] == "")
            assert (row["smime_signature"] == str(SMIMESig.un))
            assert (row["smime_encryption"] == str(SMIMEEnc.un))
            assert (row["autocrypt_data"] == '')
            assert (row["pgp_key_data_attachment"] == "[]")
            assert (row["pgp_signature_attachment"] == str(PGPSig.un))
            assert (row["pgp_encryption_attachment"] == str(PGPEnc.un))
            assert (row["smime_error"] == "")
            assert (row["pgp_error"] == "")
            assert (row["other_error"] == "")


def test_mail5():

    #Content:
    #Ein Forward mit Applemail und SMIME Signatur

    mailnum = 5

    results_test_file = "results/results_forward_mail"+str(mailnum)+".csv"
    try:
        #Delete previous test data
        os.remove(results_test_file)
    except FileNotFoundError:
        pass
    main.main(json_input = "public_testdata/forwards/mail"+str(mailnum)+".json", csv_output = results_test_file, salt = "123".encode())

    #Ensure we don't find any of the personal data in the results file
    with open(results_test_file, 'r') as testfile:
        reader = csv.DictReader(testfile, delimiter=',', quotechar='\'')
        for row in reader:
            assert (row["user"] == "d95b463c813aa61cb0185f7c5a62c95f8b21dc47@sc.h")
            assert (row["sender"] == "91cfc03c27c14c8e4d10ea799abf3d1aa0099874@ext")
            assert (row["receiver_list"] == '["d95b463c813aa61cb0185f7c5a62c95f8b21dc47@sc.h"]')
            assert (row["cc_list"] == "[]")
            assert (row["bcc_list"] == "[]")
            assert (row["reply_to"] == "")
            assert (row["return_path"] == "8870ed84a6276d17d40036917c1964254f76f1de@ext")
            assert (row["header_date"] == "2020-11-22")
            assert (row["client"] == "Apple Mail (2.3608.120.23.2.4)")
            assert (row["folder"] == str(Postbox.inb))
            assert (row["mail_relay_count"] == "9")
            assert (row["mail_virus_scans"] == "1")
            assert (row["message_id"] == "1a4643ce504c738d1596c705bddb099fe5983447")
            #assert (row["dkim"] == "")
            assert (row["is_list"] == "0")
            assert (row["cert_data"] == '[{"sn":16360405335420557697,"not_valid_b":"2016-02-22 13:38:22","not_valid_a":"2031-02-22 23:59:59","algo":"sha256","size":2048,"type":"RSA","issuer":{"countryName":"DE","organizationName":"T-Systems Enterprise Services GmbH","organizationalUnitName":"T-Systems Trust Center","commonName":"T-TeleSec GlobalRoot Class 2"},"crl":1,"ocsp":true,"usage":{"content_commitment":false,"crl_sign":true,"data_encipherment":false,"digital_signature":false,"decipher_only":false,"encipher_only":false,"key_agreement":false,"key_cert_sign":true,"key_encipherment":false},"ext_usage":[],"subj":-1,"subju":-1}, {"sn":7709478377892925,"not_valid_b":"2016-05-24 11:38:40","not_valid_a":"2031-02-22 23:59:59","algo":"sha256","size":2048,"type":"RSA","issuer":{"countryName":"DE","organizationName":"Verein zur Foerderung eines Deutschen Forschungsnetzes e. V.","organizationalUnitName":"DFN-PKI","commonName":"DFN-Verein Certification Authority 2"},"crl":2,"ocsp":true,"usage":{"content_commitment":false,"crl_sign":true,"data_encipherment":false,"digital_signature":false,"decipher_only":false,"encipher_only":false,"key_agreement":false,"key_cert_sign":true,"key_encipherment":false},"ext_usage":[],"subj":-1,"subju":-1}, {"sn":"89fdbb54bec4b1e24be6e1fc0d465f3fa10c68ca","not_valid_b":"07:2018","not_valid_a":"07:2021","algo":"sha256","size":2048,"type":"RSA","issuer":{"countryName":"DE","organizationName":"Verein zur Foerderung eines Deutschen Forschungsnetzes e. V.","organizationalUnitName":"DFN-PKI","commonName":"DFN-Verein Global Issuing CA"},"crl":2,"ocsp":true,"usage":{"content_commitment":true,"crl_sign":false,"data_encipherment":false,"digital_signature":true,"decipher_only":false,"encipher_only":false,"key_agreement":false,"key_cert_sign":false,"key_encipherment":true},"ext_usage":["clientAuth","emailProtection"],"subj":3,"subju":2}, {"level":2}]')
            assert (row["smime_signature"] == str(SMIMESig.sig))
            assert (row["smime_encryption"] == str(SMIMEEnc.un))
            assert (row["autocrypt_data"] == '')
            assert (row["pgp_key_data_attachment"] == "[]")
            assert (row["pgp_signature_attachment"] == str(PGPSig.un))
            assert (row["pgp_encryption_attachment"] == str(PGPEnc.un))
            assert (row["smime_error"] == "")
            assert (row["pgp_error"] == "")
            assert (row["other_error"] == "")


def test_mail6():

    #Content:
    #forward with TB

    mailnum = 6

    results_test_file = "results/results_forward_mail"+str(mailnum)+".csv"
    try:
        #Delete previous test data
        os.remove(results_test_file)
    except FileNotFoundError:
        pass
    main.main(json_input = "public_testdata/forwards/mail"+str(mailnum)+".json", csv_output = results_test_file, salt = "123".encode())

    #Ensure we don't find any of the personal data in the results file
    with open(results_test_file, 'r') as testfile:
        reader = csv.DictReader(testfile, delimiter=',', quotechar='\'')
        for row in reader:
            assert (row["user"] == "d95b463c813aa61cb0185f7c5a62c95f8b21dc47@sc.h")
            assert (row["sender"] == "91cfc03c27c14c8e4d10ea799abf3d1aa0099874@ext")
            assert (row["receiver_list"] == '["d95b463c813aa61cb0185f7c5a62c95f8b21dc47@sc.h"]')
            assert (row["cc_list"] == "[]")
            assert (row["bcc_list"] == "[]")
            assert (row["reply_to"] == "")
            assert (row["return_path"] == "8870ed84a6276d17d40036917c1964254f76f1de@ext")
            assert (row["header_date"] == "2020-11-22")
            assert (row["client"] == "Mozilla/5.0 (Macintosh; Intel Mac OS X 10.15; rv:68.0) Gecko/20100101 Thunderbird/68.12.0")
            assert (row["folder"] == str(Postbox.inb))
            assert (row["mail_relay_count"] == "9")
            assert (row["mail_virus_scans"] == "1")
            assert (row["message_id"] == "5b62b001a1da91f372e75bbf872473320ba1353c")
            #assert (row["dkim"] == "")
            assert (row["is_list"] == "0")
            assert (row["cert_data"] == '')
            assert (row["smime_signature"] == str(SMIMESig.un))
            assert (row["smime_encryption"] == str(SMIMEEnc.un))
            assert (row["autocrypt_data"] == '{"ParserKeyWord.AUTOCRYPT_STATE": "mutual", "ParserKeyWord.AUTOCRYPT_KEY": [{"type": "pub", "length": "4096", "algo": "1", "cap": "scESC", "compliance": "23", "date": "43:2016", "expires": "39:2022", "keyid": "175597d5eab0d7ff13b715d9676236ae34de593a", "subkey_info": {"909e6f4f4d70851fa7a5b0a9fbff22754ddb872c": {"type": "sub", "length": "4096", "algo": "1", "cap": "e", "compliance": "23", "date": "43:2016", "expires": "39:2022", "keyid": "909e6f4f4d70851fa7a5b0a9fbff22754ddb872c"}}, "uids": 1}]}')
            assert (row["pgp_key_data_attachment"] == "[]")
            assert (row["pgp_signature_attachment"] == str(PGPSig.un))
            assert (row["pgp_encryption_attachment"] == str(PGPEnc.un))
            assert (row["smime_error"] == "")
            assert (row["pgp_error"] == "")
            assert (row["other_error"] == "")

def test_mail7():

    #Content:
    #forward with TB

    mailnum = 7

    results_test_file = "results/results_forward_mail"+str(mailnum)+".csv"
    try:
        #Delete previous test data
        os.remove(results_test_file)
    except FileNotFoundError:
        pass
    main.main(json_input = "public_testdata/forwards/mail"+str(mailnum)+".json", csv_output = results_test_file, salt = "123".encode())

    #Ensure we don't find any of the personal data in the results file
    with open(results_test_file, 'r') as testfile:
        reader = csv.DictReader(testfile, delimiter=',', quotechar='\'')
        for row in reader:
            assert (row["user"] == "d95b463c813aa61cb0185f7c5a62c95f8b21dc47@sc.h")
            assert (row["sender"] == "91cfc03c27c14c8e4d10ea799abf3d1aa0099874@ext")
            assert (row["receiver_list"] == '["d95b463c813aa61cb0185f7c5a62c95f8b21dc47@sc.h"]')
            assert (row["cc_list"] == "[]")
            assert (row["bcc_list"] == "[]")
            assert (row["reply_to"] == "91cfc03c27c14c8e4d10ea799abf3d1aa0099874@ext")
            assert (row["return_path"] == "8870ed84a6276d17d40036917c1964254f76f1de@ext")
            assert (row["header_date"] == "2020-11-22")
            assert (row["client"] == "ZEDAT-Webmail")
            assert (row["folder"] == str(Postbox.inb))
            assert (row["mail_relay_count"] == "10")
            assert (row["mail_virus_scans"] == "1")
            assert (row["message_id"] == "294d31007223be771daf43935f7efd4a698db6b6")
            #assert (row["dkim"] == "")
            assert (row["is_list"] == "0")
            assert (row["cert_data"] == '')
            assert (row["smime_signature"] == str(SMIMESig.un))
            assert (row["smime_encryption"] == str(SMIMEEnc.un))
            assert (row["autocrypt_data"] == '')
            assert (row["pgp_key_data_attachment"] == "[]")
            assert (row["pgp_signature_attachment"] == str(PGPSig.un))
            assert (row["pgp_encryption_attachment"] == "{'version': '3', 'algo': '1', 'keyid': '17e4f7690dd7069e383efc328b30e23e9396f48c', 'data': 'packet:', 'level': 2}")
            assert (row["smime_error"] == "")
            assert (row["pgp_error"] == "")
            assert (row["other_error"] == "")

def test_mail8():

    #Content:
    #Hallo, bei der Nachricht habe ich die Signatur extra hinzugefügt.

    mailnum = 8

    results_test_file = "results/results_forward_mail"+str(mailnum)+".csv"
    try:
        #Delete previous test data
        os.remove(results_test_file)
    except FileNotFoundError:
        pass
    main.main(json_input = "public_testdata/forwards/mail"+str(mailnum)+".json", csv_output = results_test_file, salt = "123".encode())

    #Ensure we don't find any of the personal data in the results file
    with open(results_test_file, 'r') as testfile:
        reader = csv.DictReader(testfile, delimiter=',', quotechar='\'')
        for row in reader:
            assert (row["user"] == "d95b463c813aa61cb0185f7c5a62c95f8b21dc47@sc.h") # stransky@sec.uni-hannover.de
            assert (row["sender"] == "91cfc03c27c14c8e4d10ea799abf3d1aa0099874@ext") # oliver.wiese@fu-berlin.de
            assert (row["receiver_list"] == '["7fbba9184d3c0d2253da051cdb6db27cffe25f19@ext", "8ca3c7bbd026d1eb22204d4f3b8cefda6159708b@ext", "d95b463c813aa61cb0185f7c5a62c95f8b21dc47@sc.h"]') # stransky@sec.uni-hannover.de
            assert (row["cc_list"] == '["7fbba9184d3c0d2253da051cdb6db27cffe25f19@ext", "8ca3c7bbd026d1eb22204d4f3b8cefda6159708b@ext", "d95b463c813aa61cb0185f7c5a62c95f8b21dc47@sc.h"]')
            assert (row["bcc_list"] == "[]")
            assert (row["reply_to"] == "")
            assert (row["return_path"] == "8870ed84a6276d17d40036917c1964254f76f1de@ext") # wieseoli@zedat.fu-berlin.de
            assert (row["header_date"] == "2020-11-22")
            assert (row["client"] == "Mozilla/5.0 (Macintosh; Intel Mac OS X 10.15; rv:68.0) Gecko/20100101 Thunderbird/68.12.0")
            assert (row["folder"] == str(Postbox.inb))
            assert (row["mail_relay_count"] == "9")
            assert (row["mail_virus_scans"] == "1")
            assert (row["message_id"] == "a51c27124433474c694bc8940fb86dd411b7a9e0")
            #assert (row["dkim"] == "")
            assert (row["is_list"] == "0")
            assert (row["cert_data"] == "")
            assert (row["smime_signature"] == str(SMIMESig.un))
            assert (row["smime_encryption"] == str(SMIMEEnc.un))
            assert (row["autocrypt_data"] == '{"ParserKeyWord.AUTOCRYPT_STATE": "mutual", "ParserKeyWord.AUTOCRYPT_KEY": [{"type": "pub", "length": "4096", "algo": "1", "cap": "scESC", "compliance": "23", "date": "43:2016", "expires": "39:2022", "keyid": "175597d5eab0d7ff13b715d9676236ae34de593a", "subkey_info": {"909e6f4f4d70851fa7a5b0a9fbff22754ddb872c": {"type": "sub", "length": "4096", "algo": "1", "cap": "e", "compliance": "23", "date": "43:2016", "expires": "39:2022", "keyid": "909e6f4f4d70851fa7a5b0a9fbff22754ddb872c"}}, "uids": 1}]}')
            assert (row["pgp_key_data_attachment"] == "[]")
            assert (row["pgp_signature_attachment"] == str(PGPSig.un))
            assert (row["pgp_encryption_attachment"] == str(PGPEnc.un))
            assert (row["smime_error"] == "")
            assert (row["pgp_error"] == "")
            assert (row["other_error"] == "")