from parser import PGPHelper
from parser import KeyWords
from parser import parser

def alice_key():
    file = "data/Alice(439EE43C)–Public.asc"
    f = open(file, 'r')
    data = f.read()
    return  data

def signature():
    file = "data/signature.asc"
    f = open(file, 'r')
    data = f.read()
    return  data

def test_basic_PGPKey():
    keys = PGPHelper.read_key(alice_key())
    assert (len(keys) == 1)
    print(keys)
    key = keys[0]
    assert (key['type'] == 'pub')
    assert (key['length'] == '4096')
    assert (key['algo'] == '1')
    assert (key['keyid'] == '20B23B6D439EE43C')
    assert (key['date'] == '1562363140')
    assert (key['expires'] == '')
    assert (key['cap'] == 'scESC')
    assert (len(key['uids']) == 3)
    """
    [{'type': 'pub', 'trust': '-', 'length': '4096', 'algo': '1', 'keyid': '20B23B6D439EE43C', 'date': '1562363140', '
    expires': '', 'dummy': '', 'ownertrust': '-', 'sig': '', 'cap': 'scESC', 'issuer': '', 'flag': '', 'token': '', 
    'hash': '', 'curve': '', 'compliance': '23', 'updated': '', 'origin': '0', 
    'uids': ['Alice <alice@letterbox-app.org>', 'Alice2 <alice2@letterbox-app.org>', 'Alice3 <alice3@letterbox-app.org>'], 
    'sigs': [], 'subkeys': [['8959D1782F6B34B7', '', '0A5FA6EFFB5CE8A4CF4AEC108959D1782F6B34B7']], 
    'fingerprint': 'E740C21507CA640E688C9AB620B23B6D439EE43C', 
    'subkey_info': {'8959D1782F6B34B7': 
        {'type': 'sub', 'trust': '-', 'length': '4096', 'algo': '1', 'keyid': '8959D1782F6B34B7', 'date': '1562363140', 'expires': '', 'dummy': ''
    , 'ownertrust': '', 'uid': '', 'sig': '', 'cap': 'e', 'issuer': '', 'flag': '', 'token': '', 'hash': '',
     'curve': '', 'compliance': '23', 'updated': '', 'origin': 'unavailable'}}}]
    """

def test_basic_autocryptHeader():
    data = """
    Autocrypt:  addr=xaskdljasoidjas@sdfsaf.com; prefer-encrypt=mutual; keydata=
 mQINBFgNwGABEAC5KgyebtaoREglO01VZoKrvwl9JqpnmmlRNs9ViG3vY4aVIFz2UTvdBbZf
 y88tKInL8fU1Ph2wlnEOKZWji4w0+nQhbS7YdLFmPcpazfM8fBjqZdxlHLVemssDPvYMDvwm
 TrxUQNDqIXRNnA9krCmARtc2H8+ovRu1bT1TNv9DXQwex2NsyGlJ0c9mnvp9FGwJUr0/hqes
 XJ7dyhvd7Rn1iss2vKMbLHAZuI2jw9yyZGLhlhrQaTxDAayedOKuFr7vzAGsONSvxHviM1R0
 RSk0z/xwXoyjzkWc0Hy9hFl7iaaP0C96HfkBwcTh/oiKjLcsMn4555BorT2ErCy1VoKh6ZXS
 nz7aBo8++01sLo9v5Y3bFCNeQXp9FLfMKEbWC6V1J/lws2Rdg8mDA2J8pUaMDcIcUXfWfxCV
 6AFLCRVqytsxJhNBBs1+h/zNkwGE8ogEjdUJgsUN4cfjSuAC1iEmNJkp7EnLbmMpRizUHfxY
 xQ7oOsQKcF7BUKv9QloMl5f1rnCRkq+d0Qb+U0JXadti7Jrz7fAD3BVXDTT0JvRpU9pLbLqc
 MT/KkMxxfKw+P4UWI1phP1n94xdJ2CdjlTWOq7x2N0ZdpUteacjarZN5vp+k9QWg137BU1rZ
 Xvnh+CZa17Z15EsKVKdwkPWRqdCLtRoL2XylHgNSQ9X84tghEQARAQABtChPbGl2ZXIgV2ll
 c2UgPG9saXZlci53aWVzZUBmdS1iZXJsaW4uZGU+iQJXBBMBCgBBAhsDBQkHhh+ABQsJCAcD
 BRUKCQgLBRYCAwEAAh4BAheAFiEEgU/2vFBmngURM4VOLvBudETz6W8FAlhHxdwCGQEACgkQ
 LvBudETz6W/+fg/9HRsp1w7DMEyb+kPbczahqaZftykLzL/lndnt4BqPXF99FFdeBHoO08WY
 rol2gJmGpC5ji2W3Mnt6fHt6Bv4yDBiAWFNwSU28kvPOevDBPyVuRVqKpk7zwy3rDRWRqQW2
 /I2w1cbqnOxnMGn8ccYKiH+krrI4G72zN0DNrgQWGIRRfGFDOVLoSlHvi9qFgTstsv0EZsg9
 Q39S9u/OZFe+6W1NzQG4nrE5jZ88G5pMnjohMOpJNYJBjfC6ld+q3KXsEEqr/UvefoSv9lnA
 wjKK9cEtt3HLffBRIkMAWXLWbuX6crRLiGbmiUuZCHv+MfeinUGigmGhZzcLF6Z/FrJlGFRa
 WY4m4l1AwBq8b3MFTdMwnjhAg4Azl1g8Bx8607oxsHhRS+VLA4Qm6IxOI1bR82eBoWy+AAgi
 mviTDgGPmH/ByD+911GaL1utp52BajZeUrIRSRd2cCWCxv93fU802OVdWQLV5WRO08xfP4s0
 3PorC5WBnVqQ2QJd836P4A51wdim4BO7m3tGKxZyKPBxA4zvMA4cjbR4fbCo7LaM1muEKo4L
 e7J0UJEEUk6rYHcT83VmXNPInJwUZ0ywCSwaLmh8N8goqPfxi8eXl4qh6w9yo4mtW+5X++tb
 GdDHd5s+f1EjP1OjwiMNWP577Folp5cvEi8/cUfyLjYb4QbJMke5Ag0EWA3AYAEQAMwsnUSy
 BJ2kFulhNMGgWX+kk6vgTBpxXpm66R5vS8J3MP64yGM2VkELtGW1JK5gwF7NdAXp9thbb8ow
 IEPYW1r4iFKVERoq/YTySjfzjcOzr8nGMj9Cvg2h1RXbD8yIOxZmLoDwnVhrYPnB9xNuW8yb
 vEL2/Oq2d+1jPk9zmbjJR5qAGBhBbPN26izPa96p7An7K+NzTAWam+VwWPeRKGdtGIZbDCCp
 i1Zxd/toT7zcY0+J4RUd1w7BZqKD76YIGJF0hHco2wAoBc8/v0jYICu8YSlHH7rCrKsyie+8
 4Q4upfv/sVFLigY+ASqkGhCy3uYPv57mZuO3p2zzQ4GrkeoR5a0XgCe6UxQ7dy3D6BQgE+GU
 Ixp5ERJH4NN2D+6cKQBpbe8DsqE4qmWXQg8Isx36l/nnVaSnxMtQq3Z6tHPC1VfKu4l/y1gF
 zzXKxTKkYPb+tDdObGcLTIdda/Q4ANUWTKKgpPQz02B0TncbhYYUBj4BseIAFb6UGWG+qb2Q
 6oBPFAg1NFajXobJFu/RDoN3f+w3ry/SpbynCte2kRP+1oRM73c89JoWUbV+WJ1l6jjZQ6Ik
 7fIZtCzt/Qx+jHzSbS2ZVdkH489fBXOcPaLHWirWU40f4r8VAeB/4fDkcew1En6h4CF+GwhD
 S0ihC7tmWqbHBiVTYX5cEw2bqLx5ABEBAAGJAiUEGAEKAA8FAlgNwGACGwwFCQeGH4AACgkQ
 LvBudETz6W9T2A//ZoaABnRT/t7RZcC8lcmWRfem4yvXjLjlMaUeh/loVxmXu9r9hOg6Wm0e
 RWm1pImH+Q9E2veFBQHWGHycOFxBEo2Hj0ipeP5ZM7/HQbsTKtBPR5vPXpJq4w8gFlSdxCOy
 5ohL5QOF5JXVjHFV8DUBTokCun0V1IjwVRQT+qWHUxna1ABkKUiPIXfJNWBEj0LWPk+cndz/
 f3YEqtPvlGDf1TGxQDMe0XhbMFgP1sWgHKHwo1m5MKrczLbbbf4UMh/6fObijfwXLB9UoB1W
 lem19twLScM1ZtJ+NcEcIKFVMBGr86Qwsk6O9ioPcezzIsMhayobepx6A4N3t/s3I76i5oWn
 p075w9dpK8GaEHSSfITKj85IdXje9q+N3qQD5fWtZyvBXlMwFRpRgEgFSggHnaTJiF6CFxqb
 Zc5AEPULhpziToFoawdE7X08I2s0Swloe4BRxVTS9nAtdp9iaG3gMCRwiTrewZux5rvDyTRd
 /w2lbVOhRCVpP5HAHelARlShoQ9Viu6pABWnLLU2ulQtenoagv2l1EnJ583b+1EaajgWOFY2
 yLYxjaMwlBAcSfARLVmuHh4pKfOlb/Ir0tvNALiD6Rw8zquOqVKigpAaw0hS5eV6eSqdafeW
 O31IKCkg63j7QVjwLZlT9XiQjC6BsfBe+IP8DRNWT+cIdch2mU4="""
    result = PGPHelper.parse_autocrypt_header(data)
    assert(result[KeyWords.ParserKeyWord.AUTOCRYPT_STATE] == 'mutual')
    assert (len(result[KeyWords.ParserKeyWord.AUTOCRYPT_KEY]) == 1)
    key = result[KeyWords.ParserKeyWord.AUTOCRYPT_KEY][0]
    assert (key['keyid'] == '2EF06E7444F3E96F')

def test_added_keys_detection():
    data = parser.read_json_file("data/fetch_json_new.json")
    result = parser.json_data_to_mails(data)
    mail = result[16]
    key_counter = 0
    for item in mail:
        if item.key == parser.KeyWords.ParsedData.PGP_KEY_DATA_ATTACHMENT:
            print(item.key, len(item.value))
            key_counter = key_counter + len(item.value)
    assert (key_counter == 2)


def test_signature_detection():
    data = parser.read_json_file("data/fetch_json_new.json")
    result = parser.json_data_to_mails(data)

    assert (len(result) >= 33)
    # 14,26 = inline PGP signed
    # 10,24 = SMIME signed (+enc?)
    signed_mails = [0,5,6,11,13,14,15,16,23,24,31,33]
    for i in signed_mails:
        is_signed = False
        mail = result[i]
        for item in mail:
            if item.key == parser.KeyWords.ParsedData.PGP_SIGNATURE_ATTACHMENT or item.key == parser.KeyWords.ParsedData.PGP_SIGNATURE_INLINE:
                assert (item.value != "")
                is_signed = True
        assert(is_signed)

    i = 0
    for signed_mail in result:
        if not i in signed_mails:
            for item in signed_mail:
                if item.key == parser.KeyWords.ParsedData.PGP_SIGNATURE_ATTACHMENT or item.key == parser.KeyWords.ParsedData.PGP_SIGNATURE_INLINE:
                    assert (item.value == "")
        i = i + 1

def test_encryption_detection():
    data = parser.read_json_file("data/fetch_json_new.json")
    result = parser.json_data_to_mails(data)

    assert (len(result) >= 32)
    # 30,32 = inline PGP enc
    encrypted_mails = [1,25,26,27,28,29,30]
    for i in encrypted_mails:
        is_signed = False
        mail = result[i]
        for item in mail:
            if item.key == parser.KeyWords.ParsedData.PGP_ENCRYPTION_ATTACHMENT or item.key == parser.KeyWords.ParsedData.PGP_ENCRYPTION_INLINE:
                assert (item.value != "")
                is_signed = True
        assert(is_signed)

    i = 0
    for mail in result:
        if not i in encrypted_mails:
            for item in mail:
                if item.key == parser.KeyWords.ParsedData.PGP_ENCRYPTION_ATTACHMENT or item.key == parser.KeyWords.ParsedData.PGP_ENCRYPTION_INLINE:
                    assert (item.value == "")
        i = i + 1