import base64
import mailparser
import OpenSSL
import datetime

from parser import CertHelper, parser, KeyWords
from records.Types import SMIMEEnc, SMIMESig

signed = r'''Return-Path: <oliver.wiese@fu-berlin.de>
Delivered-To: stransky@sec.uni-hannover.de
Received: from mail-proxy2.luis.uni-hannover.de ([127.0.0.1])
	by imap1.p6.rrzn.uni-hannover.de (Dovecot) with LMTP id c3D+Kj8Zp10yPAIAZsCWPQ
	for <stransky@sec.uni-hannover.de>; Wed, 16 Oct 2019 15:21:03 +0200
Received: from mail-proxy2.luis.uni-hannover.de ([127.0.0.1])
	by mail-proxy2.luis.uni-hannover.de (Dovecot) with LMTP id NiagI7AXp106HwAAGtkGKA
	; Wed, 16 Oct 2019 15:21:03 +0200
Received: from mailin-int-2.uni-hannover.de (mailin-int-2.uni-hannover.de [130.75.2.117])
	by mail-proxy2.luis.uni-hannover.de (Postfix) with ESMTPS id AE2C8401B4
	for <stransky@sec.uni-hannover.de>; Wed, 16 Oct 2019 15:21:03 +0200 (CEST)
Received: from a1121.mx.srv.dfn.de (a1121.mx.srv.dfn.de [194.95.232.47])
	by mailin-int-2.uni-hannover.de (Postfix) with ESMTPS id AB2031FE86
	for <stransky@sec.uni-hannover.de>; Wed, 16 Oct 2019 15:21:03 +0200 (CEST)
Received: from localhost (localhost [127.0.0.1])
	by a1121.mx.srv.dfn.de (Postfix) with ESMTP id A7274240174
	for <stransky@sec.uni-hannover.de>; Wed, 16 Oct 2019 15:21:03 +0200 (CEST)
X-DFN-Virus-Scanned: Debian amavisd-new at mgw1-han.srv.dfn.de
Received: from a1121.mx.srv.dfn.de ([127.0.0.1])
	by localhost (mgw1-han.srv.dfn.de [127.0.0.1]) (amavisd-new, port 20013)
	with ESMTP id ac01acaJYedu for <stransky@sec.uni-hannover.de>;
	Wed, 16 Oct 2019 15:21:02 +0200 (CEST)
Received: from outpost1.zedat.fu-berlin.de (outpost1.zedat.fu-berlin.de [130.133.4.66])
	by a1121.mx.srv.dfn.de (Postfix) with ESMTPS
	for <stransky@sec.uni-hannover.de>; Wed, 16 Oct 2019 15:20:59 +0200 (CEST)
Received: from inpost2.zedat.fu-berlin.de ([130.133.4.69])
          by outpost.zedat.fu-berlin.de (Exim 4.85)
          for stransky@sec.uni-hannover.de with esmtps (TLSv1.2:ECDHE-RSA-AES256-GCM-SHA384:256)
          (envelope-from <oliver.wiese@fu-berlin.de>)
          id <1iKjEZ-0005Sp-Kc>; Wed, 16 Oct 2019 15:20:59 +0200
Received: from [194.94.98.190] (helo=[192.168.236.190])
          by inpost2.zedat.fu-berlin.de (Exim 4.85)
          for stransky@sec.uni-hannover.de with esmtpsa (TLSv1.2:ECDHE-RSA-AES256-GCM-SHA384:256)
          (envelope-from <oliver.wiese@fu-berlin.de>)
          id <1iKjEZ-002zd4-EO>; Wed, 16 Oct 2019 15:20:59 +0200
From: Oliver Wiese <oliver.wiese@fu-berlin.de>
Content-Type: multipart/signed;
	boundary="Apple-Mail=_0F16EE15-F9D3-4F87-A154-C8BB545CD89E";
	protocol="application/pkcs7-signature";
	micalg=sha-256
Mime-Version: 1.0 (Mac OS X Mail 12.4 \(3445.104.11\))
Subject: Signed with smime mail
Message-Id: <381EDBB7-20C1-4453-82D7-7FF2CE733B2A@fu-berlin.de>
Date: Wed, 16 Oct 2019 15:20:59 +0200
To: Christian Stransky <stransky@sec.uni-hannover.de>
X-Mailer: Apple Mail (2.3445.104.11)
X-Originating-IP: 194.94.98.190
X-ZEDAT-Hint: A


--Apple-Mail=_0F16EE15-F9D3-4F87-A154-C8BB545CD89E
Content-Transfer-Encoding: 7bit
Content-Type: text/plain;
	charset=us-ascii

this is a signed mail but not encrypted.
--Apple-Mail=_0F16EE15-F9D3-4F87-A154-C8BB545CD89E
Content-Disposition: attachment;
	filename=smime.p7s
Content-Type: application/pkcs7-signature;
	name=smime.p7s
Content-Transfer-Encoding: base64
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==
--Apple-Mail=_0F16EE15-F9D3-4F87-A154-C8BB545CD89E--
'''

signed_encrypted = r'''Return-Path: <oliver.wiese@fu-berlin.de>
Delivered-To: stransky@sec.uni-hannover.de
Received: from mail-proxy2.luis.uni-hannover.de ([127.0.0.1])
	by imap1.p6.rrzn.uni-hannover.de (Dovecot) with LMTP id glHZG9/hpl1ZEwIAZsCWPQ
	for <stransky@sec.uni-hannover.de>; Wed, 16 Oct 2019 11:24:47 +0200
Received: from mail-proxy2.luis.uni-hannover.de ([127.0.0.1])
	by mail-proxy2.luis.uni-hannover.de (Dovecot) with LMTP id oxwpF8fhpl06IQAAGtkGKA
	; Wed, 16 Oct 2019 11:24:47 +0200
Received: from mailin-int-2.uni-hannover.de (mailin-int-2.uni-hannover.de [130.75.2.117])
	by mail-proxy2.luis.uni-hannover.de (Postfix) with ESMTPS id B776340236
	for <stransky@sec.uni-hannover.de>; Wed, 16 Oct 2019 11:24:47 +0200 (CEST)
Received: from a1121.mx.srv.dfn.de (a1121.mx.srv.dfn.de [194.95.232.47])
	by mailin-int-2.uni-hannover.de (Postfix) with ESMTPS id B443A1FE86
	for <stransky@sec.uni-hannover.de>; Wed, 16 Oct 2019 11:24:47 +0200 (CEST)
Received: from localhost (localhost [127.0.0.1])
	by a1121.mx.srv.dfn.de (Postfix) with ESMTP id B01BA2401E4
	for <stransky@sec.uni-hannover.de>; Wed, 16 Oct 2019 11:24:47 +0200 (CEST)
X-DFN-Virus-Scanned: Debian amavisd-new at mgw1-han.srv.dfn.de
Received: from a1121.mx.srv.dfn.de ([127.0.0.1])
	by localhost (mgw1-han.srv.dfn.de [127.0.0.1]) (amavisd-new, port 20013)
	with ESMTP id E1YIn5t1pkLH for <stransky@sec.uni-hannover.de>;
	Wed, 16 Oct 2019 11:24:17 +0200 (CEST)
Received: from outpost1.zedat.fu-berlin.de (outpost1.zedat.fu-berlin.de [130.133.4.66])
	by a1121.mx.srv.dfn.de (Postfix) with ESMTPS
	for <stransky@sec.uni-hannover.de>; Wed, 16 Oct 2019 11:24:17 +0200 (CEST)
Received: from inpost2.zedat.fu-berlin.de ([130.133.4.69])
          by outpost.zedat.fu-berlin.de (Exim 4.85)
          for stransky@sec.uni-hannover.de with esmtps (TLSv1.2:ECDHE-RSA-AES256-GCM-SHA384:256)
          (envelope-from <oliver.wiese@fu-berlin.de>)
          id <1iKfXV-000zT9-40>; Wed, 16 Oct 2019 11:24:17 +0200
Received: from [194.94.98.191] (helo=[192.168.236.235])
          by inpost2.zedat.fu-berlin.de (Exim 4.85)
          for stransky@sec.uni-hannover.de with esmtpsa (TLSv1.2:ECDHE-RSA-AES256-GCM-SHA384:256)
          (envelope-from <oliver.wiese@fu-berlin.de>)
          id <1iKfXU-002J6P-Rg>; Wed, 16 Oct 2019 11:24:17 +0200
Content-Type: application/pkcs7-mime;
	name=smime.p7m;
	smime-type=enveloped-data
Mime-Version: 1.0 (Mac OS X Mail 12.4 \(3445.104.11\))
Subject: Signed and enc mail
Content-Disposition: attachment;
	filename=smime.p7m
From: Oliver Wiese <oliver.wiese@fu-berlin.de>
In-Reply-To: <86000717-bbd9-6cd0-c988-f438879637ac@sec.uni-hannover.de>
Date: Wed, 16 Oct 2019 11:24:15 +0200
Content-Transfer-Encoding: base64
Message-Id: <E2A2A114-FD7B-4F84-B098-DC165253AB33@fu-berlin.de>
References: <424186B8-EF2B-467A-B5AC-F2A047DCD604@fu-berlin.de>
 <453fa73e-f346-a3eb-b100-e69ba5dc39bc@sec.uni-hannover.de>
 <86000717-bbd9-6cd0-c988-f438879637ac@sec.uni-hannover.de>
To: Christian Stransky <stransky@sec.uni-hannover.de>
X-Mailer: Apple Mail (2.3445.104.11)
X-Originating-IP: 194.94.98.191
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'''

encrypted_only = r'''Return-Path: <oliver.wiese@fu-berlin.de>
Delivered-To: stransky@sec.uni-hannover.de
Received: from mail-proxy2.luis.uni-hannover.de ([127.0.0.1])
	by imap1.p6.rrzn.uni-hannover.de (Dovecot) with LMTP id 1bTsAcvhpl1jLQIAZsCWPQ
	for <stransky@sec.uni-hannover.de>; Wed, 16 Oct 2019 11:24:27 +0200
Received: from mail-proxy2.luis.uni-hannover.de ([127.0.0.1])
	by mail-proxy2.luis.uni-hannover.de (Dovecot) with LMTP id bkWlNb3gpl3tHgAAGtkGKA
	; Wed, 16 Oct 2019 11:24:27 +0200
Received: from mailin-int-3.uni-hannover.de (mailin-int-3.uni-hannover.de [130.75.2.116])
	by mail-proxy2.luis.uni-hannover.de (Postfix) with ESMTPS id 47BCC40236
	for <stransky@sec.uni-hannover.de>; Wed, 16 Oct 2019 11:24:27 +0200 (CEST)
Received: from c1121.mx.srv.dfn.de (c1121.mx.srv.dfn.de [194.95.238.47])
	by mailin-int-3.uni-hannover.de (Postfix) with ESMTPS id 40E3160905
	for <stransky@sec.uni-hannover.de>; Wed, 16 Oct 2019 11:24:27 +0200 (CEST)
Received: from localhost (localhost [127.0.0.1])
	by c1121.mx.srv.dfn.de (Postfix) with ESMTP id 25CE6A01F8
	for <stransky@sec.uni-hannover.de>; Wed, 16 Oct 2019 11:24:27 +0200 (CEST)
X-DFN-Virus-Scanned: Debian amavisd-new at mgw1-erl.srv.dfn.de
Received: from c1121.mx.srv.dfn.de ([127.0.0.1])
	by localhost (mgw1-erl.srv.dfn.de [127.0.0.1]) (amavisd-new, port 20013)
	with ESMTP id X7UsnVOe2OTf for <stransky@sec.uni-hannover.de>;
	Wed, 16 Oct 2019 11:24:26 +0200 (CEST)
Received: from outpost1.zedat.fu-berlin.de (outpost1.zedat.fu-berlin.de [130.133.4.66])
	by c1121.mx.srv.dfn.de (Postfix) with ESMTPS
	for <stransky@sec.uni-hannover.de>; Wed, 16 Oct 2019 11:24:26 +0200 (CEST)
Received: from inpost2.zedat.fu-berlin.de ([130.133.4.69])
          by outpost.zedat.fu-berlin.de (Exim 4.85)
          for stransky@sec.uni-hannover.de with esmtps (TLSv1.2:ECDHE-RSA-AES256-GCM-SHA384:256)
          (envelope-from <oliver.wiese@fu-berlin.de>)
          id <1iKfXe-000zYv-El>; Wed, 16 Oct 2019 11:24:26 +0200
Received: from [194.94.98.191] (helo=[192.168.236.235])
          by inpost2.zedat.fu-berlin.de (Exim 4.85)
          for stransky@sec.uni-hannover.de with esmtpsa (TLSv1.2:ECDHE-RSA-AES256-GCM-SHA384:256)
          (envelope-from <oliver.wiese@fu-berlin.de>)
          id <1iKfXe-002J6P-A8>; Wed, 16 Oct 2019 11:24:26 +0200
Content-Type: application/pkcs7-mime;
	name=smime.p7m;
	smime-type=enveloped-data
Mime-Version: 1.0 (Mac OS X Mail 12.4 \(3445.104.11\))
Subject: Enc only
Content-Disposition: attachment;
	filename=smime.p7m
From: Oliver Wiese <oliver.wiese@fu-berlin.de>
In-Reply-To: <86000717-bbd9-6cd0-c988-f438879637ac@sec.uni-hannover.de>
Date: Wed, 16 Oct 2019 11:24:25 +0200
Content-Transfer-Encoding: base64
Message-Id: <83364AE2-4AB0-439E-9008-60AAD43C2185@fu-berlin.de>
References: <424186B8-EF2B-467A-B5AC-F2A047DCD604@fu-berlin.de>
 <453fa73e-f346-a3eb-b100-e69ba5dc39bc@sec.uni-hannover.de>
 <86000717-bbd9-6cd0-c988-f438879637ac@sec.uni-hannover.de>
To: Christian Stransky <stransky@sec.uni-hannover.de>
X-Mailer: Apple Mail (2.3445.104.11)
X-Originating-IP: 194.94.98.191

MIAGCSqGSIb3DQEHA6CAMIACAQAxggN2MIIBtwIBADCBnjCBjTELMAkGA1UEBhMCREUxRTBDBgNV
BAoMPFZlcmVpbiB6dXIgRm9lcmRlcnVuZyBlaW5lcyBEZXV0c2NoZW4gRm9yc2NodW5nc25ldHpl
cyBlLiBWLjEQMA4GA1UECwwHREZOLVBLSTElMCMGA1UEAwwcREZOLVZlcmVpbiBHbG9iYWwgSXNz
dWluZyBDQQIMHquxIGDgCGtc8ZZZMA0GCSqGSIb3DQEBAQUABIIBAFR8Akp/cSL46fs9LSSH201o
IKtiom1vPjQ9wibRR8wFU3tPyevRm4pr17hCDnUWy7FeLz+9rhc6eXsF1/Oz6ZDfe4HhM540XqLj
1ZHqJ/O0Sz/Na0ZWx33odQkWep0voBZnPl64y0uvB6VC8iGDPgcH+M5NCFWVQo1mp6DnIbDcT/QI
+hUM+yxpilZy7GTpdUFQkntxHw65O40QxTKwmnNp2zhArAgX5OnRn0w/ahx1bvQ0tJ1QRjz1MuHw
5SfNyTTNvTrPrlOzKaVGeffGgdRovUgbANTkAZsYE5Lyox/Armthf4MsHShS6yUSE+wVOo8mEUp+
ct1LUMOeU9DkgZIwggG3AgEAMIGeMIGNMQswCQYDVQQGEwJERTFFMEMGA1UECgw8VmVyZWluIHp1
ciBGb2VyZGVydW5nIGVpbmVzIERldXRzY2hlbiBGb3JzY2h1bmdzbmV0emVzIGUuIFYuMRAwDgYD
VQQLDAdERk4tUEtJMSUwIwYDVQQDDBxERk4tVmVyZWluIEdsb2JhbCBJc3N1aW5nIENBAgwgwt/f
aavb+X+4rzwwDQYJKoZIhvcNAQEBBQAEggEAU6+oMpUzhGQ5egCuwaBtV7NLp3Nj8CiyYKvhte6s
ZgrlyQ0F41yO3jKfC/62E9vW0jhJEDLWvV3evzvNrqC7oCzqn2AvvjEvd8EEfCe3J2IOJdF1HHyy
g538lRtdSXkXZ2jzmBeyrCU87jY5HeqHyT2yl8WV3wKskmgMl97iFB5iPXCHAviG14mERLa/Eknn
Atg98SwZhLtZ7oop0O2hjisxY2fZUFan7aOWVYFPDY/Gv9VjYKyh4qS5pasvmJxLV4N9/LNPjJMm
dpT1BuxLwoX35Qk46nSZte35d8EeUoZXYdpo4XroMMI4/mwkk5E0BU418+kS66lsyoXzXiyFxzCA
BgkqhkiG9w0BBwEwHQYJYIZIAWUDBAEqBBD8ONUmei4oIdFTKKTHPw+XoIAEIN1ioXBrCy90MloM
zQtzunr+iaTnQohxNcxGO785jz5dBCDpTHrrl97o7eq7OUqoill+bI+uvtclc0uQd3JE87KNoQQQ
meGyERLitaMC8ITDqX2mBwQQW2c7y0JPGgMVN0S46FCYmQQwyrqUCvjEJEWobtHzpiZSNYNMFs7Z
x0vZBMpdk5b+63l/glbD6bjJsWh2W1oyMBKuBCC0FJah5edTdXwRKT7g7tzVhTw2uhJ2L9Sbc7eW
XZgjEgQQI2Xc6LhzIXZ4zKo31P9FmwQQfP/LWed7sBndW4z0DeW2VQQwU5seUxMmzo3QSXC5SOMw
kOXXI0wcv4MhqgpkfUHjYNo+hbCjKg8Pq5urI2QRKfafBDAknsi1sPOv5XbkBHPFqUDC+XZ35o6L
aEJkINOsOi7pp9m8Rxma6Vka6EOqDzVjGscEMGpjdC78az9MHtnCayYFnlki9dafu8outBg64f8s
O52cz3uD35QJsc7VZVAFXSKcsAQg4Dl0N0tbXnLsufbn/TYhGR5p4HpVSwSKlTseamoNwi4EEGel
lda8j4ppsIGHcvkefE0EEE0dyGflDidnHEBiMqaLvZsAAAAAAAAAAAAA
'''

def read_mail_no_parser(mail):
    for attachment in mail.attachments:
        yield parser.parse_attachment(attachment)

def read_mail(mailcontent):
    #Parse mail with mailparser to get attachments
    mail = mailparser.parse_from_string(mailcontent)
    return read_mail_no_parser(mail)

def test_smime_signed():
    result = list(read_mail(signed))[0]
    assert(result[0][0] == KeyWords.ParsedData.CERT_DATA)
    assert(len(result[0][1]) == 3) #3 Certs

    #DFN Root Cert
    assert(result[0][1][0].subject_alt_names == -1) #TODO: Should we get more data here?
    assert(result[0][1][0].subject_alt_names_unique == -1)
    assert(result[0][1][0].signature_hash_algorithm == "sha256")
    assert(result[0][1][0].key_size == 2048)
    assert(result[0][1][0].key_type == "RSA")
    assert(result[0][1][0].crl_endpoints == 1) # Only a single Telesec CRL Endpoint
    assert(result[0][1][0].ocsp_endpoint == True)
    assert(result[0][1][0].key_usage["content_commitment"] == False)
    assert(result[0][1][0].key_usage["crl_sign"] == True)
    assert(result[0][1][0].key_usage["data_encipherment"] == False)
    assert(result[0][1][0].key_usage["decipher_only"] == False)
    assert(result[0][1][0].key_usage["digital_signature"] == False)
    assert(result[0][1][0].key_usage["encipher_only"] == False)
    assert(result[0][1][0].key_usage["key_agreement"] == False)
    assert(result[0][1][0].key_usage["key_cert_sign"] == True)
    assert(result[0][1][0].key_usage["key_encipherment"] == False)
    assert(result[0][1][0].extended_key_usage == [])
    assert(result[0][1][0].not_valid_before == datetime.datetime(2016, 2, 22, 13, 38, 22))
    assert(result[0][1][0].not_valid_after == datetime.datetime(2031, 2, 22, 23, 59, 59))
    assert(result[0][1][0].serial_number == 16360405335420557697)

    #DFN-Verein Global Issuing CA
    assert(result[0][1][1].subject_alt_names == -1) #TODO: Should we get more data here?
    assert(result[0][1][1].subject_alt_names_unique == -1)
    assert(result[0][1][1].signature_hash_algorithm == "sha256")
    assert(result[0][1][1].key_size == 2048)
    assert(result[0][1][1].key_type == "RSA")
    assert(result[0][1][1].crl_endpoints == 2)
    assert(result[0][1][1].ocsp_endpoint == True)
    assert(result[0][1][1].key_usage["content_commitment"] == False)
    assert(result[0][1][1].key_usage["crl_sign"] == True)
    assert(result[0][1][1].key_usage["data_encipherment"] == False)
    assert(result[0][1][1].key_usage["decipher_only"] == False)
    assert(result[0][1][1].key_usage["digital_signature"] == False)
    assert(result[0][1][1].key_usage["encipher_only"] == False)
    assert(result[0][1][1].key_usage["key_agreement"] == False)
    assert(result[0][1][1].key_usage["key_cert_sign"] == True)
    assert(result[0][1][1].key_usage["key_encipherment"] == False)
    assert(result[0][1][1].extended_key_usage == [])
    assert(result[0][1][1].not_valid_before == datetime.datetime(2016, 5, 24, 11, 38, 40))
    assert(result[0][1][1].not_valid_after == datetime.datetime(2031, 2, 22, 23, 59, 59))
    assert(result[0][1][1].serial_number == 7709478377892925)

    #Client Cert
    assert(result[0][1][2].subject_alt_names == 3)
    assert(result[0][1][2].subject_alt_names_unique == 2)
    assert(result[0][1][2].signature_hash_algorithm == "sha256")
    assert(result[0][1][2].key_size == 2048)
    assert(result[0][1][2].key_type == "RSA")
    assert(result[0][1][2].crl_endpoints == 2)
    assert(result[0][1][2].ocsp_endpoint == True)
    assert(result[0][1][2].key_usage["content_commitment"] == True)
    assert(result[0][1][2].key_usage["crl_sign"] == False)
    assert(result[0][1][2].key_usage["data_encipherment"] == False)
    assert(result[0][1][2].key_usage["decipher_only"] == False)
    assert(result[0][1][2].key_usage["digital_signature"] == True)
    assert(result[0][1][2].key_usage["encipher_only"] == False)
    assert(result[0][1][2].key_usage["key_agreement"] == False)
    assert(result[0][1][2].key_usage["key_cert_sign"] == False)
    assert(result[0][1][2].key_usage["key_encipherment"] == True)
    assert(result[0][1][2].extended_key_usage == ['clientAuth', 'emailProtection'])
    assert(result[0][1][2].not_valid_before == datetime.datetime(2018, 2, 20, 14, 41, 22))
    assert(result[0][1][2].not_valid_after == datetime.datetime(2021, 2, 19, 14, 41, 22))
    assert(result[0][1][2].serial_number == 9492113065938320616164791897)
    assert(result[1][0] == KeyWords.ParsedData.SMIME_SIGNATURE)
    assert(result[1][1] == SMIMESig.sig)
    print(result)

def test_smime_signed_encrypted():
    result = list(read_mail(signed_encrypted))[0]
    assert(result[0][0] == KeyWords.ParsedData.SMIME_ENCRYPTION)
    assert(result[0][1] == SMIMEEnc.enc)
    assert(result[1][0] == KeyWords.ParsedData.SMIME_SIGNATURE)
    assert(result[1][1] == SMIMESig.unknown)
    print(result)

def test_smime_encrypted():
    result = list(read_mail(encrypted_only))[0]
    assert(result[0][0] == KeyWords.ParsedData.SMIME_ENCRYPTION)
    assert(result[0][1] == SMIMEEnc.enc)
    assert(result[1][0] == KeyWords.ParsedData.SMIME_SIGNATURE)
    assert(result[1][1] == SMIMESig.unknown)
    print(result)