from records.Types import *
import pytest

'''
@pytest.fixture(scope='session')
def engine():
    return create_engine('sqlite://:memory:')


@pytest.yield_fixture(scope='session')
def tables(engine):
    BaseModel.metadata.create_all(engine)
    yield
    BaseModel.metadata.drop_all(engine)


@pytest.yield_fixture
def dbsession(engine, tables):
    """Returns an sqlalchemy session, and after the test tears down everything properly."""
    connection = engine.connect()
    # begin the nested transaction
    transaction = connection.begin()
    # use the connection with the already started transaction
    session = Session(bind=connection)

    yield session

    session.close()
    # roll back the broader transaction
    transaction.rollback()
    # put back the connection to the connection pool
    connection.close()
'''

def test_mime():
    assert find_mime("text/plain") == MIME.TextPlain
    assert find_mime("crap") == MIME.Other

def test_postbox():
    assert find_postbox("INBOX") == Postbox.inb
    assert find_postbox("sent") == Postbox.sent
    assert find_postbox("sent_sub") == Postbox.sent_sub
    assert find_postbox("SpAm") == Postbox.spam
    assert find_postbox("junk") == Postbox.junk
    assert find_postbox("30dTrash") == Postbox.trash_30d
    assert find_postbox("sdkghskjfghsikjhilg") == Postbox.Other

def test_charset():
    assert find_charset("ISO885915") == Charset.ISO885915
    assert find_charset("CRAP") == Charset.Other